<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatable-index-usuarios').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla

  dataTable.on("click", ".eliminar", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id; // Asumiendo que el ID se encuentra en la propiedad 'id'

      swal({
        title: "¿Seguro deseas eliminar?",
        text: "Una vez eliminado no se podra volver a recuperar",
        icon: "warning",
        buttons: true,
        dangerMode: true,
        buttons: ["Cancelar", "Eliminar"],
        confirmButtonClass: "btn-warning",
        cancelButtonClass: "btn-danger"
      })
        .then((willDelete) => {
          if (willDelete) {
            axios.delete(route('usuarios.destroy',id))
              .then(response => {
                console.log(response);
                swal("Ha sido eliminado exitosamente", {
                  icon: "success",
                  buttons: false
                });
                setTimeout(function () {
                  location.reload();
                }, 1000);
              })
              .catch(error => {
                console.error(error);
                swal("Cancelado", {
                  icon: "error"
                });
              });
          } else {
            console.log('Salvado')
            swal("Cancelado", {
              icon: "error"
            });
          }
        });
    }
  });
  

  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = route('usuarios.show',id)
      console.log(id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,

    
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'nombreCompleto' },
        { data: 'email' },
        { data: 'rol.name' },
        { data: 'nombreInstitucion' },
        {
          data: null,
          defaultContent: '<a title="Detalles" href="#a" v-on:click="detalles(id)" class="detalles text-warning"> <i class="mdi mdi-account-edit font-size-18" style="font-size: 18px;"></i></a> <a title="Eliminar" href="#a" v-on:click="eliminar(id)" class="eliminar text-danger"> <i class="mdi mdi-delete font-size-18" style="font-size: 18px;"></i></a>',
          targets: -1
        }
      ],
      botones: [
        {
          title: 'Lista de usuarios',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
           columns: [1,2, 3, 4,] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
          }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatable-index-usuarios').DataTable();
    this.getProducts();
  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('usuarios.get.all')).then(
        response => {
          swal.close()
          this.products = response.data
        }
      )
    },
    filtroBusqueda() {

      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });

  axios.get(route('particulares.get.all.sancionados', {rfc:this.rfc,institucionesIds:this.InstitucionesIds,tiposFaltaIds:this.faltaIds,responsablesSancionIds:this.responsableSancionIds,tiposSancionIds:this.sancionesIds,fechaInicial:this.fechaInicial,fechaFinal:this.fechaFinal,rango:this.rango}))
   .then(response => {
    console.log(response.data)
     this.products = response.data
    swal.close();




   })
   .catch(error => {

    console.log(error)

     
   

    swal("Error en el filtrado", {
             icon: "error"
           });
   });
 
},
    create: function (event) {
      window.location.href = route('usuarios.create')

    }
  }
}
</script>

<template>
  <div class="main-content">
    <div class="page-content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <div class=" d-grid gap-2 d-md-flex justify-content-md-end dropdown float-end">
                  <button type="button" v-on:click="create" id="btn-registrar" class="btn btn-info waves-effect">
                    <i class="bx bx-add-to-queue font-size-16 align-middle me-2"></i> Añadir usuario
                  </button>
                </div>

                <h4 class="card-title mb-4">Lista de usuarios</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatable-index-usuarios" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    }, buttons:botones}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 10px;">
                          <div class="form-check font-size-16 align-middle">
                            <input class="form-check-input" type="checkbox" id="transactionCheck01">
                            <label class="form-check-label" for="transactionCheck01"></label>
                          </div>
                        </th>
                        <th class="align-middle text-center" style="width: 15%;">Nombre</th>
                        <th class="align-middle text-center" style="width: 15%;">Nombre de usuario</th>
                        <th class="align-middle text-center" style="width: 25%;">Rol</th>
                        <th class="align-middle text-center" style="width: 25%;">Institucion</th>
                        <th class="align-middle text-center" style="width: 10;">Acciones</th>
                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <footer class="footer"></footer>
  </div>
</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable-index-usuarios{
  margin-top: 10px;
}



.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
